
<template>
  <BasicLayout>
    <template #wrapper>
      <el-card class="box-card">
        <el-form ref="queryForm" :model="queryParams" :inline="true" label-width="90px" label-position="left">
          <el-form-item label="交易对" prop="symbol"><el-input
            v-model="queryParams.symbol"
            placeholder="请输入交易对"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
          </el-form-item>
          <el-form-item label="基础货币" prop="baseAsset"><el-input
            v-model="queryParams.baseAsset"
            placeholder="请输入基础货币"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
          </el-form-item>
          <el-form-item label="计价货币" prop="quoteAsset"><el-input
            v-model="queryParams.quoteAsset"
            placeholder="请输入计价货币"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
          </el-form-item>
          <el-form-item label="交易对类型" prop="type">
            <el-select v-model="queryParams.type" placeholder="请选择交易对类型" clearable size="small">
              <el-option v-for="dict in [{ label:'现货',value:'1'},{label:'合约',value:'2'}]" :key="dict.value" :label="dict.label" :value="dict.value" />
            </el-select>
          </el-form-item>

          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:lineSymbol:add']"
              type="primary"
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
            >新增
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:lineSymbol:edit']"
              type="success"
              icon="el-icon-edit"
              size="mini"
              :disabled="single"
              @click="handleUpdate"
            >修改
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:lineSymbol:edit']"
              type="warning"
              icon="el-icon-upload"
              size="mini"
              @click="handleExport"
            >导出
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              v-permisaction="['admin:lineSymbol:remove']"
              type="danger"
              icon="el-icon-delete"
              size="mini"
              :disabled="multiple"
              @click="handleDelete"
            >删除
            </el-button>
          </el-col>
        </el-row>

        <el-table v-loading="loading" :data="lineSymbolList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center" /><el-table-column
            label="交易对"
            align="center"
            prop="symbol"
            :show-overflow-tooltip="true"
          /><el-table-column
            label="基础货币"
            align="center"
            prop="baseAsset"
            :show-overflow-tooltip="true"
          /><el-table-column
            label="计价货币"
            align="center"
            prop="quoteAsset"
            :show-overflow-tooltip="true"
          />
          <el-table-column
            label="状态"
            align="center"
            prop="switch"
            :show-overflow-tooltip="true"
          >
            <template #default="{row}"><el-tag size="mini" :type="['danger','success'][row.switch]">{{ ['已关闭','已开启'][row.switch] }}</el-tag></template>
          </el-table-column>

          <el-table-column
            label="交易对类型"
            align="center"
            prop="type"
            :show-overflow-tooltip="true"
          >
            <template #default="{row}">
              {{ ['现货','合约'][row.type-1] || '' }}
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-popconfirm
                class="delete-popconfirm"
                title="确认要修改吗?"
                confirm-button-text="修改"
                @confirm="handleUpdate(scope.row)"
              >
                <el-button
                  slot="reference"
                  v-permisaction="['admin:lineSymbol:edit']"
                  size="mini"
                  type="text"
                  icon="el-icon-edit"
                >修改
                </el-button>
              </el-popconfirm>
              <el-popconfirm
                class="delete-popconfirm"
                title="确认要删除吗?"
                confirm-button-text="删除"
                @confirm="handleDelete(scope.row)"
              >
                <el-button
                  slot="reference"
                  v-permisaction="['admin:lineSymbol:remove']"
                  size="mini"
                  type="text"
                  icon="el-icon-delete"
                >删除
                </el-button>
              </el-popconfirm>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageIndex"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />

        <!-- 添加或修改对话框 -->
        <el-dialog :title="title" :visible.sync="open" width="500px">
          <el-form ref="form" :model="form" :rules="rules" label-width="100px">

            <el-form-item label="api账户id" prop="apiId">
              <el-input
                v-model="form.apiId"
                placeholder="api账户id"
              />
            </el-form-item>
            <el-form-item label="交易对" prop="symbol">
              <el-input
                v-model="form.symbol"
                placeholder="交易对"
              />
            </el-form-item>
            <el-form-item label="基础货币" prop="baseAsset">
              <el-input
                v-model="form.baseAsset"
                placeholder="基础货币"
              />
            </el-form-item>
            <el-form-item label="计价货币" prop="quoteAsset">
              <el-input
                v-model="form.quoteAsset"
                placeholder="计价货币"
              />
            </el-form-item>
            <el-form-item label="状态" prop="switch">
              <el-switch
                v-model="form.switch"
                active-color="#13ce66"
                inactive-color="#ff4949"
                active-text="开启"
                inactive-text="关闭"
                active-value="1"
                inactive-value="0"
              />
            </el-form-item>
            <el-form-item label="交易对类型" prop="type">
              <el-radio-group v-model="form.type">
                <el-radio label="1">现货</el-radio>
                <el-radio label="2">合约</el-radio>
              </el-radio-group>
            </el-form-item>
          </el-form>
          <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
          </div>
        </el-dialog>
      </el-card>
    </template>
  </BasicLayout>
</template>

<script>
import { resolveBlob } from '@/utils/zipdownload'
import { addLineSymbol, delLineSymbol, getLineSymbol, listLineSymbol, updateLineSymbol, exportSymbols } from '@/api/admin/line-symbol'

export default {
  name: 'LineSymbol',
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      open: false,
      isEdit: false,
      // 类型数据字典
      typeOptions: [],
      lineSymbolList: [],

      // 关系表类型

      // 查询参数
      queryParams: {
        pageIndex: 1,
        pageSize: 10,
        symbol: undefined,
        baseAsset: undefined,
        quoteAsset: undefined,
        type: undefined

      },
      // 表单参数
      form: {
      },
      // 表单校验
      rules: { symbol: [{ required: true, message: '交易对不能为空', trigger: 'blur' }],
        baseAsset: [{ required: true, message: '基础货币不能为空', trigger: 'blur' }],
        quoteAsset: [{ required: true, message: '计价货币不能为空', trigger: 'blur' }],
        type: [{ required: true, message: '交易对类型不能为空', trigger: 'blur' }]
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    // 获取杠杆api用户
    // getListLineApiUser(){
    //   listLineApiUser({pageIndex:1,pageSize:999}).then(response => {
    //     this.lineUsers = response.data.list
    //     this.lineTotal = response.data.count
    //   })
    // },
    // 交易对列表
    getSymbol(type) {
      const { pageIndex } = this.symbol
      listLineSymbol({ pageIndex, pageSize: 6, type: type || this.form.order_type }).then(res => {
        this.symbol.total = res.data.count
        this.symbol.symbolList = res.data.list
      })
    },
    // 获取交易对组
    // getSymbolGroup() {
    //   listLineSymbolGroup({ pageIndex:1, pageSize: 999,beginTime:undefined,endTime:undefined}).then(res => {
    //     this.symbolGroups = res.data.list
    //   })
    // },
    onCalc() {
      if (!this.inForm.price || !this.percenter) {
        return 0
      }
      let res
      if (this.inForm.site === 'BUY') {
        res = (1 - (this.percenter / 100)) * Number(this.inForm.price)
      } else {
        res = (1 + (this.percenter / 100)) * Number(this.inForm.price)
      }
      const [num, decimal] = String(res).split('.')
      console.log(num, decimal, '?')
      if (decimal) {
        this.inForm.price = decimal.length > 4 ? `${num}.${decimal.substring(0, 4)}` : res
      } else {
        this.form.price = res
      }
    },
    /** 查询参数列表 */
    getList() {
      this.loading = true
      listLineSymbol(this.queryParams).then(response => {
        this.lineSymbolList = response.data.list
        this.total = response.data.count
        this.loading = false
      }
      )
    },
    // 取消按钮
    cancel() {
      this.open = false
      this.reset()
    },
    // 表单重置
    reset() {
      this.form = {

        id: undefined,
        apiId: undefined,
        symbol: undefined,
        baseAsset: undefined,
        quoteAsset: undefined,
        switch: '1',
        type: '1'
      }
      this.resetForm('form')
    },
    getImgList: function() {
      this.form[this.fileIndex] = this.$refs['fileChoose'].resultList[0].fullUrl
    },
    fileClose: function() {
      this.fileOpen = false
    },
    // 关系
    // 文件
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageIndex = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加交易对管理'
      this.isEdit = false
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset()
      const id =
                row.id || this.ids
      getLineSymbol(id).then(response => {
        this.form = response.data
        this.open = true
        this.title = '修改交易对管理'
        this.isEdit = true
      })
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs['form'].validate(valid => {
        if (valid) {
          if (this.form.id !== undefined) {
            updateLineSymbol(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess(response.msg)
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          } else {
            addLineSymbol(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess(response.msg)
                this.open = false
                this.getList()
              } else {
                this.msgError(response.msg)
              }
            })
          }
        }
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      var Ids = (row.id && [row.id]) || this.ids

      this.$confirm('是否确认删除编号为"' + Ids + '"的数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(function() {
        return delLineSymbol({ 'ids': Ids })
      }).then((response) => {
        if (response.code === 200) {
          this.msgSuccess(response.msg)
          this.open = false
          this.getList()
        } else {
          this.msgError(response.msg)
        }
      }).catch(function() {
      })
    },
    handleExport() {
      this.$confirm('确认导出当前页面数据吗?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        exportSymbols(this.queryParams).then(res => {
          resolveBlob(res, '交易对导出数据')
          this.msgSuccess('导出成功')
        })
      })
    }
  }
}
</script>
